#include <bits/stdc++.h>

using namespace std;
const int MAXN = 30010, MAXM = 100010;

int n, m, cnt[MAXN], p[MAXN], u[MAXN], d[MAXN];

int find_leader(int i)
{
    return (i == p[i]) ? i :
           (p[i] = find_leader(p[i]));
}

void unite(int v1, int v2)
{
    int p1 = find_leader(v1);
    int p2 = find_leader(v2);
    if (p1 == p2)
        return;
    p[v1] = p2;
}
int main()
{
    cin >> n >> m;
    for (int i = 1; i <= n; i ++)
        p[i] = i;
    int v1, v2;
    for (int i = 1; i <= m; i ++)
    {
        cin >> v1 >> v2;
        if (v1 != v2)
        {
            cnt[v1] ++;
            cnt[v2] ++;
        }
        unite(v1, v2);
    }

    for (int i = 1; i <= n; i ++)
        find_leader(i), u[p[i]] = 1;

    int sp = 0;
    for (int i = 1; i <= n; i ++)
    {
        int need = 0;
        if (cnt[i] % 2 == 1)
            need = 1;
        d[p[i]] += need;
    }

    vector < int > v;
    int comp = 0, ans = 0;
    for (int i = 1; i <= n; i ++)
    {
        if (u[i] == 1)
        {
            ans = ans + d[i] / 2;
            v.push_back(d[i]);
        }
    }

    sort(v.begin(), v.end());
    comp = v.size();

    cout << ans << endl;
    return 0;
}
