#include <iostream>
using namespace std;
#define endl '\n'
int cnt[64];
void add(long long x) {
    int br=0;
    while (x>0) {
        if (x%2) cnt[br]++;
        x/=2;
        br++;
    }
}
void removex(long long x) {
    int br=0;
    while (x>0) {
        if (x%2) cnt[br]--;
        x/=2;
        br++;
    }
}
long long find_xor() {
    long long res=0;
    for (long long i=0;i<63;i++) {
        if (cnt[i]%2) res+=(1<<i);
    }
    return res;
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, q, type;
    long long x;
    cin >> n >> q;
    for (int i=0;i<n;i++) {
        cin >> x;
        add(x);
    }
    for (int i=0;i<q;i++) {
        cin >> type;
        if (type==3) {
            x=find_xor();
            if (x==0) cout << n << endl;
            else cout << 0 << endl;
        } else if (type==1) {
            cin >> x;
            removex(x);
            n--;
        } else {
            cin >> x;
            add(x);
            n++;
        }
    }
    return 0;
}
