#include <iostream>
#include <utility>
#include <queue>
#define endl '\n'
using namespace std;

bool used[6005][6005];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, s;
    cin >> n >> s;

    for (int i = 1; i <= n; ++ i)
    {
        int x, y;
        cin >> x >> y;
        used[x + 3000][y + 3000] = true;
    }

    long long cnt0 = 0, cnt1 = 0;
    int br = 0;
    queue< pair< pair<int, int>, int> > q;
    q.push(make_pair(make_pair(3000, 3000), 0));
    used[3000][3000] = true;
    while (!q.empty())
    {
        int x = q.front().first.first, y = q.front().first.second, cnt = q.front().second;
        q.pop();
        if (cnt % 2 == 0) cnt0++;
        else cnt1++;
        if (cnt == s) continue;
        if (!used[x + 1][y])
        {
            used[x + 1][y] = true;
            q.push(make_pair(make_pair(x + 1, y), cnt + 1));
        }
        if (!used[x - 1][y])
        {
            used[x - 1][y] = true;
            q.push(make_pair(make_pair(x - 1, y), cnt + 1));
        }
        if (!used[x][y + 1])
        {
            used[x][y + 1] = true;
            q.push(make_pair(make_pair(x, y + 1), cnt + 1));
        }
        if (!used[x][y - 1])
        {
            used[x][y - 1] = true;
            q.push(make_pair(make_pair(x, y - 1), cnt + 1));
        }
        br++;
    }

    cout << cnt0 << " " << cnt1 << endl;

    return 0;
}
