#include <iostream>
#include <queue>
using namespace std;
#define endl '\n'
#define int long long
#define MAXN 2021
int br, s;
bool obstacle[MAXN][MAXN];
int good, bad;
bool u[MAXN][MAXN];
bool corner(int x, int y)
{
    return (x == 3 && y == 2007) || (x == 2007 && y == 3) || (x == 3 && y == 3) || (x == 2007 && y == 2007);
}
bool edge(int x, int y)
{
    return ((x == 3 || x == 2007) || (y == 3 || y == 2007)) && !corner(x, y);
}
pair<int, int> dirs[4] = {{-1, 0}, {1, 0}, {0, -1}, {0, 1}};
void dfs(int x, int y, int dep)
{
    if(obstacle[x][y]) return;
    u[x][y] = 1;
    if(dep > s) return;


}
struct el{
    int x, y, dep;
    el(){}
    el(int _x, int _y, int _dep){
        x = _x; y = _y; dep = _dep;
    }
};
bool exist(int x, int y)
{
    return x >= 3 && x <= 2007 && y >= 3 && y <= 2007;
}
queue<el> q;
int cornercnt, edgecnt;
void bfs(int sx, int sy, int sdep)
{
    q.push(el(sx, sy, sdep));
    while(!q.empty()){
        el e = q.front(); q.pop();
        int x = e.x, y = e.y, dep = e.dep;
        if(obstacle[x][y]) continue;
        //if(u[x][y]) continue;
        u[x][y] = 1;
        if(dep > s) continue;

        if(dep % 2 == 0) ++good;
        else ++bad;
        bool cool;
        if(dep % 2 == 0) cool = true;
        else cool = false;
        //cout << x - 1005 << ' ' << y - 1005 << ' ' << cool << endl;
        if(edge(x, y)){
            edgecnt++;
            int rem = s - dep;
            if(cool){
                bad += (rem + 1) / 2;
                good += rem / 2;
            }
            else{
                good += (rem + 1) / 2;
                bad += rem / 2;
            }
        }
        if(corner(x, y)){
            cornercnt++;
            int rem = s - dep;
            if(rem == 0) continue;
            if(cool){
                if(rem % 2 == 0){
                    int fgood = 3, lgood = rem + 1;
                    if(fgood <= lgood) good += (fgood + lgood) * (rem / 2) / 2;
                    int fbad = 2, lbad = rem;
                    if(fbad <= lbad) bad += (fbad + lbad) * (rem / 2) / 2;
                }
                else{
                    int fgood = 3, lgood = rem;
                    if(fgood <= lgood) good += (fgood + lgood) * (rem / 2) / 2;
                    int fbad = 2, lbad = rem + 1;
                    if(fbad <= lbad) bad += (fbad + lbad) * ((rem + 1) / 2) / 2;
                }
            }
            else{
                 if(rem % 2 == 0){
                    int fgood = 3, lgood = rem + 1;
                    if(fgood <= lgood) bad += (fgood + lgood) * (rem / 2) / 2;
                    int fbad = 2, lbad = rem;
                    if(fbad <= lbad) good += (fbad + lbad) * (rem / 2) / 2;
                }
                else{
                    int fgood = 3, lgood = rem;
                    if(fgood <= lgood) bad += (fgood + lgood) * (rem / 2) / 2;
                    int fbad = 2, lbad = rem + 1;
                    if(fbad <= lbad) good += (fbad + lbad) * ((rem + 1) / 2) / 2;
                }
            }
            continue;
        }

        for(int i = 0; i < 4; ++i){
            int newx = x + dirs[i].first, newy = y + dirs[i].second;
            if(!exist(newx, newy)) continue;
            if(u[newx][newy]) continue;
            if(obstacle[newx][newy]) continue;
            q.push(el(newx, newy, dep + 1));
            u[newx][newy] = 1;
        }
    }
}
signed main()
{
    cin.tie(0); ios::sync_with_stdio(false);
    cin >> br >> s;
    //cout << edge(3, 2007) << endl; return 0;
    for(int i = 0; i < br; ++i){
        int x, y; cin >> x >> y;
        x += 1005; y += 1005;
        obstacle[x][y] = 1;
    }
    bfs(1005, 1005, 0);
    cout << good << ' ' << bad << endl;
    //cout << edgecnt << ' ' << cornercnt << endl;
    return 0;
}
