#include <iostream>
#include <vector>
using namespace std;
#define endl '\n'
#define int long long
#define MAXN 30005
int br, edges;
int degree[MAXN];
vector<int> graph[MAXN];
int u[MAXN];
vector<int> counter;
int odd;
void dfs(int vertex)
{
    u[vertex] = 1;
    if(degree[vertex] % 2 != 0) ++odd;
    for(int att : graph[vertex]){
        if(u[att]) continue;
        dfs(att);
    }
}
signed main()
{
    cin.tie(0); ios::sync_with_stdio(false);
    cin >> br >> edges;
    for(int i = 0; i < edges; ++i){
        int from, to; cin >> from >> to;
        degree[from]++; degree[to]++;
        graph[from].push_back(to); graph[to].push_back(from);
    }
    for(int i = 1; i <= br; ++i){
        if(u[i] == 0){
            odd = 0;
            dfs(i); counter.push_back(odd);
        }
    }
    if(counter.size() == 1 && counter[0] == 0){
        cout << 0 << endl; return 0;
    }
    int rem = 0;
    for(int i = 0; i < counter.size(); ++i){
        if(counter[i] == 0) continue;
        else rem += counter[i] - 2;
    }
    cout << counter.size() + (rem / 2) << endl;
    return 0;
}
