#include<iostream>
#include<unordered_set>

#define endl '\n'

using namespace std;

unordered_multiset<int> coins;

int happy_coins(int all_xor){
    int res=0;
    for(int curr : coins){
        if(curr==(curr^all_xor)){
            ++res;
        }
    }
    return res;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n,q;
    cin>>n>>q;
    int all_xor=0;
    for(int i=0;i<n;++i){
        int curr;
        cin>>curr;
        coins.insert(curr);
        all_xor^=curr;
    }

    int res=happy_coins(all_xor);
    while(q--){
        int type;
        cin>>type;
        if(type==3){
            cout<<res<<endl;
        }else{
            int curr;
            cin>>curr;
            if(type==2){
                coins.insert(curr);
            }else{
                coins.erase(coins.find(curr));
            }
            all_xor^=curr;
            res=happy_coins(all_xor);
        }
    }
return 0;
}
