#include<bits/stdc++.h>
#define endl '\n'
#define M 1003

using namespace std;

long long otmx[4]={0, 0, 1, -1};
long long otmy[4]={1, -1, 0, 0};

struct point
{
    long long x, y, l;
    point()
    {
        l=1e9;
    }
    point(long long a, long long b, long long c)
    {
        x=a;
        y=b;
        l=c;
    }
};

bool cmpx(point p, point q)
{
    return p.x<q.x;
}

bool cmpy(point p, point q)
{
    return p.y<q.y;
}

long long dp[2100][2100];
long long n, s;
long long br1=0, br2=0;
vector<point> sp;
vector<point> sm[4];

queue<point> qu;

bool gran(point p)
{
    if(p.x==1000 || p.x==-1000 || p.y==1000 || p.y==-1000) return 1;
    return 0;
}

bool bfs()
{
    point t=point(0, 0, 0);
    qu.push(t);
    while(!qu.empty())
    {
        point tek=qu.front();
        qu.pop();
        if(tek.l>s)
        {
            cout<<br1<<" "<<br2<<endl;
            return 0;
        }
        if(tek.l%2) br2++;
        else br1++;
        for(long long i=0; i<4; i++)
        {
            long long nx=tek.x+otmx[i], ny=tek.y+otmy[i];
            if(dp[nx+M][ny+M]!=-1 || (nx>1000 || nx<-1000 || ny>1000 || ny<-1000)) continue;
            point np=point(nx, ny, tek.l+1);
            qu.push(np);
            dp[nx+M][ny+M]=tek.l+1;
            if(!gran(tek) && gran(np))
            {
                bool fl=1;
                for(int j=0; j<4; j++)
                {
                    point spo=point(nx+otmx[j], ny+otmy[j], 0);
                    if(gran(spo) && dp[spo.x+M][spo.y+M]!=-1) {fl=0; break;}
                }
                if(fl) sp.push_back(np);
            }
        }
    }
    return 1;
}

void change(long long l)
{
    ///cout<<br1<<" "<<br2<<endl;
    long long dif=s-l;
    if(dif<=0) return;
    if(l%2)
    {
        long long b1=dif/2, b2=dif/2;;
        if(dif%2) b1++;
        br1=br1+b1*(2*b1-1);
        br2=br2+b2*(2*b2+1);
    }
    else
    {
        long long b1=dif/2, b2=dif/2;;
        if(dif%2) b1++;
        br2=br2+b1*(2*b1-1);
        br1=br1+b2*(2*b2+1);
    }
    ///cout<<br1<<" "<<br2<<endl;
}

void change_c(long long l)
{
    ///cout<<br1<<" "<<br2<<endl;
    l++;
    long long dif=s-l;
    if(dif<=0) return;
    if(l%2)
    {
        long long b1=dif/2, b2=dif/2;
        if(dif%2) b1++;
        br1=br1-b1*b1;
        br2=br2-b2*(b2+1);
    }
    else
    {
        long long b1=dif/2, b2=dif/2;
        if(dif%2) b1++;
        br2=br2-b1*b1;
        br1=br1-b1*(b1+1);
    }
    ///cout<<br1<<" "<<br2<<endl;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    memset(dp, -1, sizeof(dp));
    cin>>n>>s;
    for(long long i=0; i<n; i++)
    {
        long long x, y;
        cin>>x>>y;
        dp[M+x][M+y]=-2;
    }
    dp[M][M]=0;
    if(!bfs()) return 0;
    long long brs=sp.size();
    for(long long i=0; i<brs; i++)
    {
        if(sp[i].x==1000) sm[0].push_back(sp[i]);
        if(sp[i].y==1000) sm[1].push_back(sp[i]);
        if(sp[i].x==-1000) sm[2].push_back(sp[i]);
        if(sp[i].y==-1000) sm[3].push_back(sp[i]);
    }
    sort(sm[0].begin(), sm[0].end(), cmpy);
    sort(sm[1].begin(), sm[1].end(), cmpx);
    sort(sm[2].begin(), sm[2].end(), cmpy);
    sort(sm[3].begin(), sm[3].end(), cmpx);

    for(long long i=0; i<sm[0].size(); i++)
    {
        point tek=sm[0][i];
        change(dp[tek.x+M][tek.y+M]);
    }
    for(long long i=0; i<sm[1].size(); i++)
    {
        point tek=sm[1][i];
        change(dp[tek.x+M][tek.y+M]);
    }
    for(long long i=0; i<sm[2].size(); i++)
    {
        point tek=sm[2][i];
        change(dp[tek.x+M][tek.y+M]);
    }
    for(long long i=0; i<sm[3].size(); i++)
    {
        point tek=sm[3][i];
        change(dp[tek.x+M][tek.y+M]);
    }
    change_c(dp[1000+M][1000+M]);
    change_c(dp[-1000+M][1000+M]);
    change_c(dp[1000+M][-1000+M]);
    change_c(dp[-1000+M][-1000+M]);
    cout<<br1<<" "<<br2<<endl;
    return 0;
}
/**
4 5
-1 1
0 -1
0 1
1 0
*/
