#include <iostream>
#include <queue>
using namespace std;
#define endl '\n'
const int MAXN=2e3+10;
queue <pair <pair <int,int>,int> > q;
long long S;
long long ans0, ans1;
int maxx, maxy, minx, miny;
bool cell[MAXN][MAXN], inq[MAXN][MAXN];
int mov[4][2]={{1,0},{0,1},{-1,0},{0,-1}};
void bfs() {
    q.push(make_pair(make_pair(1000,1000),0));
    inq[1000][1000]=true;
    int x, y, x1, y1, d;
    while (!q.empty()) {
        x=q.front().first.first;
        y=q.front().first.second;
        d=q.front().second;
        q.pop();
        if (d%2==0) ans0++;
        else ans1++;
        for (int k=0;k<4;k++) {
            x1=x+mov[k][0];
            y1=y+mov[k][1];
            if (d+1>S || inq[x1][y1]) continue;
            if (x1<=maxx && x1>=minx && y1<=maxy && y1>=miny && cell[x1][y1]) continue;
            inq[x1][y1]=true;
            q.push(make_pair(make_pair(x1,y1),d+1));
        }
    }
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, x, y;
    cin >> n >> S;
    maxx=maxy=-10000;
    minx=miny=-maxx;
    for (int i=0;i<n;i++) {
        cin >> x >> y;
        x+=1000; y+=1000;
        cell[x][y]=true;
        maxx=max(x+1,maxx);
        maxy=max(y+1,maxy);
        minx=min(x-1,minx);
        miny=min(y-1,miny);
    }
    if (maxx==-10000) maxx=1000;
    if (maxy==-10000) maxy=1000;
    if (minx==10000) minx=1000;
    if (miny==10000) miny=1000;
    bfs();
    cout << ans0 << ' ' << ans1 << endl;
    return 0;
}
/**

**/
