#include <iostream>
#include <queue>
using namespace std;
#define endl '\n'
const int MAXN=2e3+100;
queue <pair <int,int> > q;
long long S;
long long ans[MAXN][MAXN];
long long ans0, ans1;
int maxx, maxy, minx, miny;
bool cell[MAXN][MAXN];
int mov[4][2]={{1,0},{0,1},{-1,0},{0,-1}};
void bfs() {
    ans[1002][1002]=0;
    q.push({1002,1002});
    int x, y, x1, y1;
    while (!q.empty()) {
        x=q.front().first;
        y=q.front().second;
        if (ans[x][y]<=S) {
            if (ans[x][y]%2==0) ans0++;
            else ans1++;
        }
        q.pop();
        for (int k=0;k<4;k++) {
            x1=x+mov[k][0];
            y1=y+mov[k][1];
            if (x1>maxx || x1<minx || y1>maxy || y1<miny || cell[x1][y1] || ans[x1][y1]!=-1) continue;
            ans[x1][y1]=ans[x][y]+1;
            q.push({x1,y1});
        }
    }
}
void side(int posoka, int pos) {
    long long dif;
    if (posoka==0) {
        for (int i=minx;i<=maxx;i++) {
            if (S<=ans[i][pos]) continue;
            dif=S-ans[i][pos];
            ans0+=dif/2;
            ans1+=dif/2;
            if (dif%2==1) {
                if (S%2==0) ans0++;
                else ans1++;
            }
        }
    } else {
        for (int i=miny;i<=maxy;i++) {
            if (S<=ans[pos][i]) continue;
            dif=S-ans[pos][i];
            ans0+=dif/2;
            ans1+=dif/2;
            if (dif%2==1) {
                if (S%2==0) ans0++;
                else ans1++;
            }
        }
    }
}
void edge(int x, int y) {
    long long cur=ans[x][y]+2;
    if (cur>S) return;
    long long one=1, two=2;
    long long sum=(one+(S-cur+one))*(S-cur+one)/two;
    long long s1, s2, s3;
    s3=(S-cur)/two+one;
    s1=(one+(2*s3-1))*s3/two;
    s2=sum-s1;
    ///cout << cur << ' ' << sum << ' ' << s3 << ' ' << s1 << ' ' << s2 << endl;
    if (cur%2==0) {
        ans0+=s1;
        ans1+=s2;
    } else {
        ans1+=s1;
        ans0+=s2;
    }
}
void print_table() {
    for (int i=minx;i<=maxx;i++) {
        for (int j=miny;j<=maxy;j++) {
            if (cell[i][j]) cout << -1 << ' ';
            else cout << ans[i][j] << ' ';
        }
        cout << endl;
    }
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, x, y;
    cin >> n >> S;
    maxx=maxy=-10000;
    minx=miny=-maxx;
    for (int i=0;i<n;i++) {
        cin >> x >> y;
        x+=1002; y+=1002;
        cell[x][y]=true;
        maxx=max(x+1,maxx);
        maxy=max(y+1,maxy);
        minx=min(x-1,minx);
        miny=min(y-1,miny);
    }
    if (maxx==-10000) maxx=1002;
    if (maxy==-10000) maxy=1002;
    if (minx==10000) minx=1002;
    if (miny==10000) miny=1002;
    for (int i=minx;i<=maxx;i++) {
        for (int j=miny;j<=maxy;j++) ans[i][j]=-1;
    }
    bfs();
    ///print_table();
    side(0,maxy);
    side(1,maxx);
    side(0,miny);
    side(1,minx);
    ///cout << ans0 << ' ' << ans1 << endl;
    edge(maxx,maxy);
    edge(maxx,miny);
    edge(minx,maxy);
    edge(minx,miny);
    cout << ans0 << ' ' << ans1 << endl;
    return 0;
}
