#include<iostream>

#define endl '\n'

using namespace std;

const int MAXN=3e4+3;
int in_degree[MAXN];

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n,m;
    cin>>n>>m;
    for(int i=0;i<m;++i){
        int from,to;
        cin>>from>>to;
        --from;
        --to;
        if(from!=to){
            ++in_degree[from];
            ++in_degree[to];
        }
    }

    int res=0,needed=0;
    for(int i=0;i<n;++i){
        if(in_degree[i]%2){
            if(needed){
                ++res;
                --needed;
            }else{
                ++needed;
            }
        }else if(!in_degree[i]){
            if(needed){
                ++res;
            }else{
                needed+=2;
            }
        }
        //cout<<i<<" "<<in_degree[i]<<" "<<needed<<endl;
    }
    res+=needed;
    cout<<res<<endl;
return 0;
}
