#include<iostream>

#define endl '\n'

using namespace std;

const int MAXN=3e4+3;
int in_degree[MAXN];

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n,m;
    cin>>n>>m;
    for(int i=0;i<m;++i){
        int from,to;
        cin>>from>>to;
        --from;
        --to;
        if(from!=to){
            ++in_degree[from];
            ++in_degree[to];
        }
    }

    int res=0,needed=0,diff_nodes=0,with_two=0;
    for(int i=0;i<n;++i){
        if(in_degree[i]%2){
            if(needed){
                ++res;
                --needed;
                if(with_two){
                    --with_two;
                }else{
                    --diff_nodes;
                }
            }else{
                ++needed;
                ++diff_nodes;
            }
        }else if(!in_degree[i]){
            if(needed>1 and diff_nodes>1){
                res+=2;
                needed-=2;
                if(with_two>1){
                    with_two-=2;
                }else if(with_two==1){
                    --with_two;
                    --diff_nodes;
                }else{
                    diff_nodes-=2;
                }
            }else if((needed>1 and diff_nodes==1) or (needed==1 and diff_nodes)){
                ++res;
                if(with_two){
                    --with_two;
                }else{
                    --diff_nodes;
                }
                ++diff_nodes;
            }else{
                needed+=2;
                ++with_two;
                ++diff_nodes;
            }
        }
        //cout<<i<<" "<<in_degree[i]<<" "<<needed<<" "<<diff_nodes<<" "<<with_two<<" "<<res<<endl;
    }
    res+=needed;
    if(m==0){
        res=(n<3 ? n-1 : n);
    }
    cout<<res<<endl;
return 0;
}
