#include<iostream>
#include<unordered_map>

#define endl '\n'

using namespace std;

unordered_map<int,int> coins;

int happy_coins(int all_xor){
    int res=0;
    for(pair<int,int> curr : coins){
        if(curr.second==0){
            coins.erase(curr.first);
        }
        if(curr.first==(curr.first^all_xor)){
            res+=curr.second;
        }
    }
    return res;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n,q;
    cin>>n>>q;
    int all_xor=0;
    for(int i=0;i<n;++i){
        int curr;
        cin>>curr;
        ++coins[curr];
        all_xor^=curr;
    }

    int res=happy_coins(all_xor);
    while(q--){
        int type;
        cin>>type;
        if(type==3){
            cout<<res<<endl;
        }else{
            int curr;
            cin>>curr;
            if(type==2){
                ++coins[curr];
            }else{
                --coins[curr];
            }
            all_xor^=curr;
            res=happy_coins(all_xor);
        }
    }
return 0;
}
