#include<iostream>

#define endl '\n'

using namespace std;

const int MAXN=3e4+3;
int nums[MAXN];

long long slow2(int n){
    long long res=0;
    for(int i=0;i<n;++i){
        for(int i2=i+1;i2<n;++i2){
            res+=(long long)nums[i]*nums[i2];
        }
    }
    return res;
}

long long slow3(int n){
    long long res=0;
    for(int i=0;i<n;++i){
        for(int i2=i+1;i2<n;++i2){
            for(int i3=i2+1;i3<n;++i3){
                res+=(long long)nums[i]*nums[i2]*nums[i3];
            }
        }
    }
    return res;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n,type;
    cin>>n>>type;
    for(int i=0;i<n;++i){
        cin>>nums[i];
    }

    if(type==2){
        cout<<slow2(n)<<endl;
    }else{
        cout<<slow3(n)<<endl;
    }
return 0;
}
