#include<iostream>

#define endl '\n'

using namespace std;

const int MAXN=3e4+3,MAXM=13;
int nums[MAXN];
long long counter[MAXN];

long long slow2(int n){
    long long res=0;
    for(int i=0;i<n;++i){
        for(int i2=i+1;i2<n;++i2){
            res+=(long long)nums[i]*nums[i2];
        }
    }
    return res;
}

long long fast2(int n){
    long long res=0;
    for(long long i=1;i<11;++i){
        res+=i*i*((counter[i]*(counter[i]-1))/2);
        for(long long i2=i+1;i2<11;++i2){
            res+=i*i2*counter[i]*counter[i2];
        }
    }
    return res;
}

long long slow3(int n){
    long long res=0;
    for(int i=0;i<n;++i){
        for(int i2=i+1;i2<n;++i2){
            for(int i3=i2+1;i3<n;++i3){
                res+=(long long)nums[i]*nums[i2]*nums[i3];
            }
        }
    }
    return res;
}

long long fast3(int n){
    long long res=0;
    for(long long i=1;i<11;++i){
        res+=i*i*i*((counter[i]*(counter[i]-1)*(counter[i]-2))/6);
        for(long long i2=i+1;i2<11;++i2){
            res+=i*i*i2*((counter[i]*(counter[i]-1))/2)*counter[i2];
            res+=i2*i2*i*counter[i]*((counter[i2]*(counter[i2]-1))/2);
            for(long long i3=i2+1;i3<11;++i3){
                res+=i*i2*i3*counter[i]*counter[i2]*counter[i3];
            }
        }
    }
    return res;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n,type;
    cin>>n>>type;
    for(int i=0;i<n;++i){
        int curr;
        cin>>curr;
        ++counter[curr];
    }

    if(type==2){
        cout<<fast2(n)<<endl;
    }else{
        cout<<fast3(n)<<endl;
    }
return 0;
}
